      '           Drehzahlmesser fr 1-Zylinder 2-Takt Aprilia SR50 Motorroller
      '           Author: G.Besser
      '           Datum: 14.04.2005
      '
      '           Hardware:
      '           ---------
      '           PD0:     gelbe LED (ab 6250 Umdr./min.)
      '           PD5:     rote LED (ab 6300 Umdr./min.)
      '           PD6:     Signaleingang
      '           PB0-PB6: 7-segment - Segment A bis G
      '           PD1-PD4: 7-segment - Ziffer - Select


      $regfile = "2313def.dat"                              'AT90S2313
      $crystal = 8000000                                    '8MHz Quarz
      Ddrb = &B11111111                                     'PortB = Ausgang
      Ddrd = &B0111111                                      'PortD = Ausgang bis auf PD6

      Dim Icount As Long At &H60                            ' long = 4 Bytes, 0x60 = 1.RAM-Speicherstelle
      Dim Wcountlo As Word At &H60 Overlay                  ' word = 2 Bytes
      Dim Wcounthi As Word At &H62 Overlay
      Dim Temp As Integer At &H80                           'Temp und Temp2 sind auf derselben Speicherstelle, Problem mit INT !!
      Dim Temp2 As Integer At &H80 Overlay
      Dim Y As String * 4 At &H70
      Dim Z(4) As Byte At &H70 Overlay
      Dim Frequenz As Long
      Dim Freq As Word
      Dim Freq1 As Word
      Dim Freq2 As Word
      Dim Timeout As Byte
      Dim Impulse As Byte
      Dim X(4) As Byte
      Dim Test As Integer
      Dim Test2 As Integer
      Dim Zaehler As Byte
      Timeout = 0

      On Icp1 Oncapture
      On Ovf1 Onoverflow
      Config Timer1 = Timer , Prescale = 8 , Capture Edge = Rising
      Enable Icp1
      Enable Ovf1
      Enable Interrupts


'*******************
'* Start-Animation *
'*******************

         Zaehler = 5

      For Test2 = 1 To 40

         Portb = 9                                          'H
         Portd.1 = 0
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler

         Portb = 6                                          'E
         Portd.1 = 1
         Portd.2 = 0
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler


         Portb = 71                                         'L
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 0
         Portd.4 = 1
         Waitms Zaehler


         Portb = 64                                         'O
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 0
         Waitms Zaehler

         Next Test2

         Zaehler = 80
         Do
                                                   'Werte fuer gem. Kathode
         Portb = 254                                        '1
         Portd.1 = 0
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 0
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 0
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 0
         Waitms Zaehler
         Portb = 253                                        '2
         Waitms Zaehler
         Portb = 191                                        '64
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 0
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 0
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 0
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portb = 239                                        '16
         Waitms Zaehler
         Portb = 247                                        '8
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 0
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 0
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 0
         Waitms Zaehler
         Portb = 251                                        '4
         Waitms Zaehler
         Portb = 191                                        '64
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 1
         Portd.3 = 0
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 1
         Portd.2 = 0
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portd.1 = 0
         Portd.2 = 1
         Portd.3 = 1
         Portd.4 = 1
         Waitms Zaehler
         Portb = 223                                        '32
         Waitms Zaehler


      Loop Until Temp2 = 1                                  'Bis zum 1. Impuls



'******************************************
'* Hauptschleife - LED-Anzeigen ansteuern *
'******************************************

Main:
Incr Timeout                                                'Bei Timeout: 0 U/min.
 If Timeout = 10 Then
  Timeout = 10
  Freq = 0
  Y = Str(freq)
  Z(1) = 0
  Z(2) = 0
  Z(3) = 0
  Z(4) = 48
 End If

For Test2 = 1 To 4                                          'Wert sichern .....
 X(test2) = Z(test2)
Next Test2

For Test2 = 1 To 500                                        '..... und 500 mal Anzeigen
 For Zaehler = 1 To 4
  Test = X(zaehler)
  Select Case Test                                          '## Werte fuer 7Seg mit gem. Kathode
   Case 48 : Portb = 64                                     '63
   Case 49 : Portb = 121                                    ' 6
   Case 50 : Portb = 36                                     '91
   Case 51 : Portb = 48                                     '79
   Case 52 : Portb = 25                                     '102
   Case 53 : Portb = 18                                     '109
   Case 54 : Portb = 2                                      '125
   Case 55 : Portb = 120                                    '39
   Case 56 : Portb = 0                                      '127
   Case 57 : Portb = 24                                     '111
   Case Else : Portb = 255                                  '0
  End Select
  Portd.zaehler = 0                                         '1 ########## geaendert gebe
'  Waitus 100                                                'Zeit fr jede Anzeige
  Waitus 200                                                'Zeit fr jede Anzeige
  Portd.zaehler = 1                                         '0 ########## geaendert gebe
  Next Zaehler
Next Test2

Goto Main




'*************************************
'* Interrupt-Routine (Zeiten messen) *
'* (wird bei jedem Impuls ausgelst) *
'*************************************

Oncapture:
 Disable Icp1
 Incr Impulse
 If Impulse = 8 Then                                        'Anzeige verzoegern = Wert erhoehen
  Impulse = 0                                               'Zeit zw. 8 Impulsen wird gemessen
  Timeout = 0
  Wcountlo = Timer1
  Timer1 = 0
  Frequenz = 360000000 / Icount                             'Umrechnung fr 4-Zylinder = 240000000
  Wcounthi = 0                                              '##### 2-Takter = 480000000 gebe
  Freq2 = Freq1                                             '140000000
  Freq1 = Frequenz
  Frequenz = Freq1 + Freq2
  Frequenz = Frequenz / 2
  Freq = Frequenz

  If Freq > 5999 Then Portd.0 = 1 Else Portd.0 = 0          ' gelbe LED ab 6000 U/min
  If Freq > 6099 Then Portd.5 = 1 Else Portd.5 = 0          ' rote LED ab 6100 U/min
  If Freq < 150 Then
   Freq = 0
   Y = Str(freq)
   Z(1) = 0
   Z(2) = 0
   Z(3) = 0
   Z(4) = 48

  Else

   Y = Str(freq)
   If Z(4) = 0 Then                                         'Fhrende Nullen eliminieren
    Do
     Z(4) = Z(3)
     Z(3) = Z(2)
     Z(2) = Z(1)
     Z(1) = 0
    Loop Until Z(4) > 0
   End If
  End If
 End If

 Temp = 1
 Enable Icp1
Return

Onoverflow:
 Incr Wcounthi
Return